Shows the date of the last activity on Projects administration
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version: 6.0.0   

Resolution: Fixed   

Description

On Administration > Projects, it shows the date of the last activity on each project. Helps the admin to decide when to close or

archive stale projects.

Related issues:

Related to Redmine - Patch #13696: Projects admin, show issues count New

Related to Redmine - Feature #29482: Query system for Projects page Closed

Related to Redmine - Feature #805: Allow projects view to be sorted by activity New 2008-03-07

Related to Redmine - Feature #3099: Last activity time window. New 2009-04-02

Related to Redmine - Feature #40706: Enhance "Last activity" column to link t... Closed

Related to Redmine - Patch #41678: Fix lost backward compatibility about retu... Closed

Related to Redmine - Defect #41791: Projects endpoint returns list of all pro... Closed

Associated revisions

Revision 22811 - 2024-05-03 15:14 - Marius BĂLTEANU

Adds the date of the last activity to the list of available columns for Projects (#23954).

Patch by Frederico Camara (@fredsdc) and Marius BĂLTEANU (@marius.balteanu).

Revision 22817 - 2024-05-11 10:00 - Go MAEDA

Update locales (#23954).

Revision 22848 - 2024-05-28 19:40 - Marius BĂLTEANU

Link "Last activity" column to project activity page (#40706, #23954).

Patch by Go MAEDA (@maeda).

Revision 23186 - 2024-11-03 12:53 - Marius BĂLTEANU

Adds test for #41678 (#23954).

Patch by Mizuki ISHIKAWA (user:ishikawa999).

Revision 23187 - 2024-11-03 12:56 - Marius BĂLTEANU

ProjectQuery#results_scope should return Project::ActiveRecord_Relation to keep the backward compatibility (#41678, #23954).

Patch by Nishida Yuya (user:nishidayuya).

History

#1 - 2016-12-25 13:47 - Go MAEDA

- File screenshot-23954.png added

This is a screenshot of the feature.
But it should be considered that processing when event variable is nil in the following code. It causes undefined method `[]' for nil:NilClass error at the

next line.

  def last_activity(project)

    event = Redmine::Activity::Fetcher.new(User.current, :project => project).events(nil, nil, :limit => 1)[0]

    byebug

    event[:updated_on].nil? ? event[:created_on] : event[:updated_on]

  end

#2 - 2017-01-01 04:50 - Yuuki NARA

+1

#3 - 2017-01-02 14:11 - Frederico Camara

- File last_activity-1.patch added

Go Maeda,

Thank you for your reply. I had already patched production (https://github.com/fredsdc/redmine/tree/3.2-patched), and I forgot I had posted the patch

to Redmine.org. Fixed it again today to call last_activity function only once.

It now returns the project creation date if there is no activity in the project.

#4 - 2017-01-15 09:23 - Go MAEDA

- Target version set to Candidate for next major release

Thank you for updating the patch. It works fine, looks good to me.

#5 - 2017-01-24 06:10 - Go MAEDA

- Related to Patch #13696: Projects admin, show issues count added

#6 - 2017-01-24 06:23 - Go MAEDA

- Target version changed from Candidate for next major release to 3.4.0

Although Jean-Phillipe Lang wrote on #13696#note-7 as follows, last activity is very useful to maintenance projects.

We'll add this as an optional column when the project list will be made configurable (like the issue list).

 In my opinion, "Last activity" is far more useful information than "Created".

Could this be a part of 3.4.0?

#7 - 2017-01-25 12:49 - Robert Schneider

Go MAEDA wrote:

In my opinion, "Last activity" is far more useful information than "Created".

 That's true!

+1

#8 - 2017-01-29 12:05 - Jean-Philippe Lang

- Target version changed from 3.4.0 to Candidate for next major release
Go MAEDA wrote:

In my opinion, "Last activity" is far more useful information than "Created".

 I'm not saying that this information is not usefull. It generates dozens of SQL queries and can make the project list really slow. We'll make this

information available once the project list can be configured, but we can't add it by default now.

#9 - 2017-02-01 19:42 - Frederico Camara

Jean-Philippe Lang wrote:

I'm not saying that this information is not usefull. It generates dozens of SQL queries and can make the project list really slow. We'll make this

information available once the project list can be configured, but we can't add it by default now.

 My thoughts exactly. I got it in production here and if you have dozens of projects, it generates lots and lots of queries. I kept it because it is just so

useful, but with 400 projects and near 2000 issues, opening the admin projects page takes near 22 seconds.

I'm studying how to better query the database. Redmine::Activity::Fetcher only uses projects as filters. I would need to construct a table with each

project id and its last activity using just a few SQL queries.

#10 - 2018-03-08 18:55 - Frederico Camara

- File last_activity-2.r3.3.patch added

- File last_activity-2.r3.4.patch added

I have a new patch. I added a new option to the fetcher library, if set, the result is a hash { project_id -> last_activity }, that I use in the view.

Summarizing I reduced the queries to one per event type, which takes now a fraction of a second to complete.

#11 - 2018-03-09 22:10 - Frederico Camara

- File last_activity-3.r3.3.patch added

- File last_activity-3.r3.4.patch added

I fixed a bug, and moved some code from the helpers to the controllers. I also had an idea how to always show some activity as Feature #3099.

#12 - 2018-09-16 13:45 - Marius BĂLTEANU

- Related to Feature #29482: Query system for Projects page added

#13 - 2019-09-21 06:02 - Yuuki NARA

- File 23954-trunk-note11.png added

It worked on Redmine trunk with the same changes. note-11

Attach a screen copy of my environment.

Last activity is not displayed for projects with 0 tickets.

However, as it can be seen from the Created column, I think that it is enough as it is.
#14 - 2019-09-21 11:58 - Marius BĂLTEANU

I think we should add this column on top of #29482.

#15 - 2019-10-15 08:50 - Ryoji Takeuchi

+1

#16 - 2019-10-26 21:26 - Marius BĂLTEANU

- File 0001-Adds-last-activity-column-to-projects-list.patch added

Based on Frederico Camara work, I've created a patch that adds the "Last activity" column to the projects list.

Sorting by this column is not possible for now because I'm not sure how to implement it easily (the last activity date is calculated based on multiple

tables).  Any suggestion is welcome.

#17 - 2019-10-26 21:43 - Marius BĂLTEANU

- File deleted (0001-Adds-last-activity-column-to-projects-list.patch)

#18 - 2019-10-26 21:45 - Marius BĂLTEANU

- File 0001-Adds-last-activity-column-to-projects-list.patch added

Slightly improved the patch in order to avoid some unnecessary joins when counting the number of results.

#19 - 2019-10-26 23:13 - Marius BĂLTEANU

- File deleted (0001-Adds-last-activity-column-to-projects-list.patch)

#20 - 2019-10-26 23:15 - Marius BĂLTEANU

- File 0001-Adds-last-activity-column-to-projects-list.patch added

#21 - 2019-10-27 01:33 - Marius BĂLTEANU

- Related to Feature #805: Allow projects view to be sorted by activity added

#22 - 2020-01-05 11:12 - Marius BĂLTEANU

- File deleted (0001-Adds-last-activity-column-to-projects-list.patch)

#23 - 2020-01-05 11:24 - Marius BĂLTEANU

- File 0001-Adds-last-activity-column-to-projects-list.patch added

- Category changed from Administration to Projects

- Assignee set to Jean-Philippe Lang

- Target version changed from Candidate for next major release to 4.2.0

Updated the patch for current trunk.

@Jean-Philippe, I'm assigning to you in order to:

review the changes proposed by Frederico Camara to activity fetcher

check for any solution to enable projects sorting by last activity date

#24 - 2020-03-29 13:58 - Toshi MARUYAMA

- Related to Feature #3099: Last activity time window. added

#25 - 2020-04-05 12:17 - Marius BĂLTEANU

- File deleted (0001-Adds-last-activity-column-to-projects-list.patch)

#26 - 2020-04-05 12:17 - Marius BĂLTEANU

- File 0001-Adds-last-activity-column-to-projects-list.patch added

Updated the patch to apply cleanly on the current trunk.
#27 - 2021-03-23 21:47 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#28 - 2021-04-21 16:12 - zumo de vidrio

Can you please share the SQL query or API request in order to get the last activity date of every project ?

#29 - 2021-04-22 00:28 - Frederico Camara

zumo de vidrio wrote:

Can you please share the SQL query or API request in order to get the last activity date of every project ?

 As a hash:

Redmine::Activity::Fetcher.new(User.current).events(nil, nil, :last_by_project => true).to_h

#30 - 2022-03-20 23:35 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

#31 - 2024-04-25 10:16 - Olivier Croquette

I am trying to identify inactive projects in an instance that I am administrating. This feature would be very useful, but unfortunately it is not available in

the releases. I have two questions:

- From the comments, I understand that the current implementation is too slow when there are many projects. Would it be possible to save the last

project activity date when it happens, instead of trying to compute it on-demand? Retrieving it would be very quick then.

- In the current release, is there any other way to get the information?

#32 - 2024-04-25 14:35 - Frederico Camara

Olivier Croquette wrote in #note-31:

- From the comments, I understand that the current implementation is too slow when there are many projects. Would it be possible to save the

last project activity date when it happens, instead of trying to compute it on-demand? Retrieving it would be very quick then.

 My institution has 444 projects (active and archived in the database). When showing all projects, 500 projects per page, it takes less than 3 seconds

to refresh the projects page that computes that information.

I don't think it's slow in the current implementation. My initial implementation (before comment #23954-10) was very slow.

- In the current release, is there any other way to get the information?

 I can think of a few, using sql, rails console, the rest api, and the activities tab in each project. Not good alternatives.

#33 - 2024-05-03 15:16 - Marius BĂLTEANU

- Status changed from New to Resolved

- Assignee changed from Jean-Philippe Lang to Marius BĂLTEANU

- Target version changed from Candidate for next major release to 6.0.0

The last activity date is now available as a column in Project query, I just committed the patch.

Frederico Camara, did you find a way to make the column sortable? or should I take a look into this?

#34 - 2024-05-03 15:16 - Marius BĂLTEANU

- Tracker changed from Patch to Feature

- Resolution set to Fixed

#35 - 2024-05-05 18:37 - Frederico Camara

Marius BĂLTEANU wrote in #note-33:

The last activity date is now available as a column in Project query, I just committed the patch.

Frederico Camara, did you find a way to make the column sortable? or should I take a look into this?
 Columns were not sortable in Admin > Projects in 4.x or 5.x. I'm yet to look into Redmine 6.0.

#36 - 2024-05-17 04:14 - Go MAEDA

- Subject changed from Shows the date of the last activity on Projects administration. to Shows the date of the last activity on Projects administration

#37 - 2024-05-17 05:11 - Go MAEDA

- Related to Feature #40706: Enhance "Last activity" column to link to project activity page added

#38 - 2024-05-28 19:42 - Marius BĂLTEANU

The column now links to Project activity page, please see r22848 (#40706).

I'm keeping this open to conclude on the sort mechanism.

#39 - 2024-10-28 21:53 - Marius BĂLTEANU

- Status changed from Resolved to Closed

I'm closing this without the option to sort by Last activity date, we will track this improvement in #805.

#40 - 2024-11-02 05:25 - Go MAEDA

- Status changed from Closed to Reopened

A fix for r22811 has been posted: Patch #41678: Fix lost backward compatibility about return type of ProjectQuery#results_scope

#41 - 2024-11-03 12:52 - Marius BĂLTEANU

- Related to Patch #41678: Fix lost backward compatibility about return type of ProjectQuery#results_scope added

#42 - 2024-11-03 12:57 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Go MAEDA wrote in #note-40:

A fix for r22811 has been posted: Patch #41678: Fix lost backward compatibility about return type of ProjectQuery#results_scope

 Fix committed, thanks!

#43 - 2024-11-20 14:17 - Holger Just

- Related to Defect #41791: Projects endpoint returns list of all projects added

Files

last_activity.patch 2.58 KB 2016-09-28 Frederico Camara

screenshot-23954.png 42.3 KB 2016-12-25 Go MAEDA

last_activity-1.patch 2.63 KB 2017-01-02 Frederico Camara

last_activity-2.r3.4.patch 4.34 KB 2018-03-08 Frederico Camara

last_activity-2.r3.3.patch 4.34 KB 2018-03-08 Frederico Camara

last_activity-3.r3.3.patch 4.95 KB 2018-03-09 Frederico Camara

last_activity-3.r3.4.patch 5.03 KB 2018-03-09 Frederico Camara

23954-trunk-note11.png 113 KB 2019-09-21 Yuuki NARA

0001-Adds-last-activity-column-to-projects-list.patch 10 KB 2020-04-05 Marius BĂLTEANU
